regina::Triangulation< dim > Class Template Referenceabstract
Triangulations | Generic triangulations

A dim-dimensional triangulation, built by gluing together dim-dimensional simplices along their (dim-1)-dimensional facets. More...

`#include <triangulation/generic.h>`

Inheritance diagram for regina::Triangulation< dim >:

## Public Types

typedef Packet | SafePointeeType
| The type of object being pointed to. More...
typedef std::vector< Simplex< dim > * >::const_iterator | SimplexIterator
| Used to iterate through top-dimensional simplices. More...
typedef std::vector< Component< dim > * >::const_iterator | ComponentIterator
| Used to iterate through connected components. More...
typedef std::vector< BoundaryComponent< dim > * >::const_iterator | BoundaryComponentIterator
| Used to iterate through boundary components. More...

## Public Member Functions

std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...
Constructors and Destructors
| Triangulation ()
| Default constructor. More...
| Triangulation (const Triangulation &copy)
| Creates a new copy of the given triangulation. More...
| Triangulation (const Triangulation &copy, bool cloneProps)
| Creates a new copy of the given triangulation, with the option of whether or not to clone its computed properties also. More...
virtual | ~Triangulation ()
| Destroys this triangulation. More...
Packet Identification
virtual PacketType | type () const =0
| Returns the unique integer ID representing this type of packet. More...
virtual std::string | typeName () const =0
| Returns an English name for this type of packet. More...
const std::string & | label () const
| Returns the label associated with this individual packet. More...
std::string | humanLabel () const
| Returns the label associated with this individual packet, adjusted if necessary for human-readable output. More...
std::string | adornedLabel (const std::string &adornment) const
| Returns the label of this packet adorned with the given string. More...
void | setLabel (const std::string &label)
| Sets the label associated with this individual packet. More...
std::string | fullName () const
| Returns a descriptive text string for the packet. More...
Tags
bool | hasTag (const std::string &tag) const
| Determines whether this packet has the given associated tag. More...
bool | hasTags () const
| Determines whether this packet has any associated tags at all. More...
bool | addTag (const std::string &tag)
| Associates the given tag with this packet. More...
bool | removeTag (const std::string &tag)
| Removes the association of the given tag with this packet. More...
void | removeAllTags ()
| Removes all associated tags from this packet. More...
const std::set< std::string > & | tags () const
| Returns the set of all tags associated with this packet. More...
Event Handling
bool | listen (PacketListener *listener)
| Registers the given packet listener to listen for events on this packet. More...
bool | isListening (PacketListener *listener)
| Determines whether the given packet listener is currently listening for events on this packet. More...
bool | unlisten (PacketListener *listener)
| Unregisters the given packet listener so that it no longer listens for events on this packet. More...
Tree Queries
Packet * | parent () const
| Determines the parent packet in the tree structure. More...
Packet * | firstChild () const
| Determines the first child of this packet in the tree structure. More...
Packet * | lastChild () const
| Determines the last child of this packet in the tree structure. More...
Packet * | nextSibling () const
| Determines the next sibling of this packet in the tree structure. More...
Packet * | prevSibling () const
| Determines the previous sibling of this packet in the tree structure. More...
Packet * | root () const
| Determines the root of the tree to which this packet belongs. More...
unsigned | levelsDownTo (const Packet *descendant) const
| Counts the number of levels between this packet and its given descendant in the tree structure. More...
unsigned | levelsUpTo (const Packet *ancestor) const
| Counts the number of levels between this packet and its given ancestor in the tree structure. More...
bool | isGrandparentOf (const Packet *descendant) const
| Determines if this packet is equal to or an ancestor of the given packet in the tree structure. More...
size_t | countChildren () const
| Returns the number of immediate children of this packet. More...
size_t | countDescendants () const
| Returns the total number of descendants of this packet. More...
size_t | totalTreeSize () const
| Determines the total number of packets in the tree or subtree for which this packet is matriarch. More...
Tree Manipulation
void | insertChildFirst (Packet *child)
| Inserts the given packet as the first child of this packet. More...
void | insertChildLast (Packet *child)
| Inserts the given packet as the last child of this packet. More...
void | insertChildAfter (Packet *newChild, Packet *prevChild)
| Inserts the given packet as a child of this packet at the given location in this packet's child list. More...
void | makeOrphan ()
| Cuts this packet away from its parent in the tree structure and instead makes it matriarch of its own tree. More...
void | reparent (Packet *newParent, bool first=false)
| Cuts this packet away from its parent in the tree structure, and inserts it as a child of the given packet instead. More...
void | transferChildren (Packet *newParent)
| Cuts all of this packet's children out of the packet tree, and reinserts them as children of the given packet instead. More...
void | swapWithNextSibling ()
| Swaps this packet with its next sibling in the sequence of children beneath their common parent packet. More...
void | moveUp (unsigned steps=1)
| Moves this packet the given number of steps towards the beginning of its sibling list. More...
void | moveDown (unsigned steps=1)
| Moves this packet the given number of steps towards the end of its sibling list. More...
void | moveToFirst ()
| Moves this packet to be the first in its sibling list. More...
void | moveToLast ()
| Moves this packet to be the last in its sibling list. More...
void | sortChildren ()
| Sorts the immediate children of this packet according to their packet labels. More...
Searching and Iterating
Packet * | nextTreePacket ()
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
const Packet * | nextTreePacket () const
| Finds the next packet after this in a complete depth-first iteration of the entire tree structure to which this packet belongs. More...
Packet * | nextTreePacket (const std::string &type)
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
const Packet * | nextTreePacket (const std::string &type) const
| Finds the next packet after this of the requested type in a complete depth-first iteration of the entire tree structure. More...
Packet * | firstTreePacket (const std::string &type)
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
const Packet * | firstTreePacket (const std::string &type) const
| Finds the first packet of the requested type in a complete depth-first iteration of the tree structure. More...
Packet * | findPacketLabel (const std::string &label)
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
const Packet * | findPacketLabel (const std::string &label) const
| Finds the packet with the requested label in the tree or subtree for which this packet is matriarch. More...
Packet Dependencies
bool | isPacketEditable () const
| Determines whether this packet can be altered without invalidating or otherwise upsetting any of its immediate children. More...
Cloning
Packet * | clone (bool cloneDescendants=false, bool end=true) const
| Clones this packet (and possibly its descendants), assigns to it a suitable unused label and inserts the clone into the tree as a sibling of this packet. More...
Simplices
size_t | size () const
| Returns the number of top-dimensional simplices in the triangulation. More...
const std::vector< Simplex< dim > * > & | simplices () const
| Returns all top-dimensional simplices in the triangulation. More...
Simplex< dim > * | simplex (size_t index)
| Returns the top-dimensional simplex at the given index in the triangulation. More...
const Simplex< dim > * | simplex (size_t index) const
| Returns the top-dimensional simplex at the given index in the triangulation. More...
Simplex< dim > * | newSimplex ()
| Creates a new top-dimensional simplex and adds it to this triangulation. More...
Simplex< dim > * | newSimplex (const std::string &desc)
| Creates a new top-dimensional simplex with the given description and adds it to this triangulation. More...
void | removeSimplex (Simplex< dim > *simplex)
| Removes the given top-dimensional simplex from this triangulation. More...
void | removeSimplexAt (size_t index)
| Removes the top-dimensional simplex at the given index in this triangulation. More...
void | removeAllSimplices ()
| Removes all simplices from the triangulation. More...
void | swapContents (Triangulation< dim > &other)
| Swaps the contents of this and the given triangulation. More...
void | moveContentsTo (Triangulation< dim > &dest)
| Moves the contents of this triangulation into the given destination triangulation, without destroying any pre-existing contents. More...
Skeletal Queries
size_t | countComponents () const
| Returns the number of connected components in this triangulation. More...
size_t | countBoundaryComponents () const
| Returns the number of boundary components in this triangulation. More...
template<int subdim>
size_t | countFaces () const
| Returns the number of subdim-faces in this triangulation. More...
std::vector< size_t > | fVector () const
| Returns the f-vector of this triangulation, which counts the number of faces of all dimensions. More...
const std::vector< Component< dim > * > & | components () const
| Returns all connected components of this triangulation. More...
const std::vector< BoundaryComponent< dim > * > & | boundaryComponents () const
| Returns all boundary components of this triangulation. More...
template<int subdim>
const FaceList< dim, subdim > & | faces () const
| Returns an object that allows iteration through and random access to all subdim-faces of this triangulation. More...
Component< dim > * | component (size_t index) const
| Returns the requested connected component of this triangulation. More...
BoundaryComponent< dim > * | boundaryComponent (size_t index) const
| Returns the requested boundary component of this triangulation. More...
template<int subdim>
Face< dim, subdim > * | face (size_t index) const
| Returns the requested subdim-face of this triangulation. More...
Basic Properties
bool | isEmpty () const
| Determines whether this triangulation is empty. More...
bool | isValid () const
| Determines if this triangulation is valid. More...
bool | hasBoundaryFacets () const
| Determines if this triangulation has any boundary facets. More...
size_t | countBoundaryFacets () const
| Returns the total number of boundary facets in this triangulation. More...
bool | isOrientable () const
| Determines if this triangulation is orientable. More...
bool | isConnected () const
| Determines if this triangulation is connected. More...
bool | isOriented () const
| Determines if this triangulation is oriented; that is, if the vertices of its top-dimensional simplices are labelled in a way that preserves orientation across adjacent facets. More...
long | eulerCharTri () const
| Returns the Euler characteristic of this triangulation. More...
Algebraic Properties
const GroupPresentation & | fundamentalGroup () const
| Returns the fundamental group of this triangulation. More...
void | simplifiedFundamentalGroup (GroupPresentation *newGroup)
| Notifies the triangulation that you have simplified the presentation of its fundamental group. More...
const AbelianGroup & | homology () const
| Returns the first homology group for this triangulation. More...
const AbelianGroup & | homologyH1 () const
| Returns the first homology group for this triangulation. More...
Skeletal Transformations
void | orient ()
| Relabels the vertices of top-dimensional simplices in this triangulation so that all simplices are oriented consistently, if possible. More...
Subdivisions, Extensions and Covers
void | makeDoubleCover ()
| Converts this triangulation into its double cover. More...
void | barycentricSubdivision ()
| Does a barycentric subdivision of the triangulation. More...
bool | finiteToIdeal ()
| Converts each real boundary component into a cusp (i.e., an ideal vertex). More...
Decompositions
size_t | splitIntoComponents (Packet *componentParent=0, bool setLabels=true)
| Splits a disconnected triangulation into many smaller triangulations, one for each component. More...
Isomorphism Testing
bool | isIdenticalTo (const Triangulation< dim > &other) const
| Determines if this triangulation is combinatorially identical to the given triangulation. More...
std::unique_ptr< Isomorphism< dim > > | isIsomorphicTo (const Triangulation< dim > &other) const
| Determines if this triangulation is combinatorially isomorphic to the given triangulation. More...
std::unique_ptr< Isomorphism< dim > > | isContainedIn (const Triangulation< dim > &other) const
| Determines if an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components). More...
template<typename OutputIterator >
size_t | findAllIsomorphisms (const Triangulation< dim > &other, OutputIterator output) const
| Finds all ways in which this triangulation is combinatorially isomorphic to the given triangulation. More...
template<typename OutputIterator >
size_t | findAllSubcomplexesIn (const Triangulation< dim > &other, OutputIterator output) const
| Finds all ways in which an isomorphic copy of this triangulation is contained within the given triangulation, possibly as a subcomplex of some larger component (or components). More...
bool | makeCanonical ()
| Relabel the top-dimensional simplices and their vertices so that this triangulation is in canonical form. More...
Building Triangulations
void | insertTriangulation (const Triangulation< dim > &source)
| Inserts a copy of the given triangulation into this triangulation. More...
void | insertConstruction (size_t nSimplices, const int adjacencies[][dim+1], const int gluings[][dim+1][dim+1])
| Inserts a given triangulation into this triangulation, where the given triangulation is described by a pair of integer arrays. More...
Exporting Triangulations
std::string | isoSig (Isomorphism< dim > **relabelling=0) const
| Constructs the isomorphism signature for this triangulation. More...
std::string | dumpConstruction () const
| Returns C++ code that can be used with insertConstruction() to reconstruct this triangulation. More...

## Static Public Attributes

static constexpr int | dimension = dim
| A compile-time constant that gives the dimension of the triangulation. More...

## Protected Types

typedef std::vector< Face< dim, subdim > * >::const_iterator | Iterator
| An iterator type for iterating through this list of faces. More...

## Protected Member Functions

void | deleteFaces ()
| Deletes all faces of dimension subdim and below. More...
void | swapFaces (FaceListSuite< dim, subdim > &other)
| Swaps all faces of dimension subdim and below with those of the given triangulation. More...
void | fillFVector (std::vector< size_t > &result) const
| Fills the given vector with the first (subdim + 1) elements of the f-vector. More...
bool | sameFVector (const FaceListSuite< dim, subdim > &other) const
| Tests whether this and the given triangulation have the same number of k-faces, for each facial dimension k ≤ subdim. More...
bool | sameDegrees (const FaceListSuite< dim, subdim > &other) const
| Tests whether this and the given triangulation have the same k-face degree sequences, for each facial dimension k ≤ subdim. More...
bool | sameDegrees (const FaceList< dim, subdim > &other) const
| Tests whether this and the given triangulation have the same subdim-face degree sequences. More...
Face< dim, subdim > * | operator[] (size_t index) const
| Returns the requested subdim-face. More...
Iterator | begin () const
| Returns an iterator pointing to the first subdim-face. More...
Iterator | end () const
| Returns an iterator pointing beyond the last subdim-face. More...
void | push_back (Face< dim, subdim > *face)
| Pushes the given face onto the end of this list. More...
void | destroy ()
| Destroys all faces in this list, and clears the list itself. More...
void | swap (FaceList< dim, subdim > &other)
| Swaps all faces in this list with those in the given list. More...

## Protected Attributes

MarkedVector< Simplex< dim > > | simplices_
| The top-dimensional simplices that form the triangulation. More...
MarkedVector< BoundaryComponent< dim > > | boundaryComponents_
| The components that form the boundary of the triangulation. More...
bool | valid_
| Is this triangulation valid? See isValid() for details on what this means. More...

## File I/O

bool | save (const char *filename, bool compressed=true) const
| Saves the subtree rooted at this packet to the given Regina data file, using Regina's native XML file format. More...
bool | save (std::ostream &s, bool compressed=true) const
| Writes the subtree rooted at this packet to the given output stream, in the format of a Regina XML data file. More...
void | writeXMLFile (std::ostream &out) const
| Writes the subtree rooted at this packet to the given output stream in Regina's native XML file format. More...
std::string | internalID () const
| Returns a unique string ID that identifies this packet. More...
bool | hasOwner () const
| Indicates whether some other object in the calculation engine is responsible for ultimately destroying this object. More...
void | writeXMLPacketTree (std::ostream &out) const
| Writes a chunk of XML containing the subtree with this packet as matriarch. More...

## Importing Triangulations

static Triangulation< dim > * | fromIsoSig (const std::string &sig)
| Recovers a full triangulation from an isomorphism signature. More...
static size_t | isoSigComponentSize (const std::string &sig)
| Deduces the number of top-dimensional simplices in a connected triangulation from its isomorphism signature. More...
void | ensureSkeleton () const
| Ensures that all "on demand" skeletal objects have been calculated. More...
bool | calculatedSkeleton () const
| Determines whether the skeletal objects and properties of this triangulation have been calculated. More...
void | calculateSkeleton ()
| Calculates all skeletal objects for this triangulation. More...
void | clearBaseProperties ()
| Clears all properties that are managed by this base class. More...
void | swapBaseProperties (TriangulationBase< dim > &other)
| Swaps all properties that are managed by this base class, including skeletal data, with the given triangulation. More...
void | writeXMLBaseProperties (std::ostream &out) const
| Writes a chunk of XML containing properties of this triangulation. More...

## Packet Administration

class | detail::SimplexBase< dim >
class | detail::TriangulationBase< dim >
virtual void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
virtual void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
virtual bool | dependsOnParent () const
| Determines if this packet depends upon its parent. More...
static XMLPacketReader * | xmlReader (Packet *parent, XMLTreeResolver &resolver)
virtual Packet * | internalClonePacket (Packet *parent) const
| Makes a newly allocated copy of this packet. More...
virtual void | writeXMLPacketData (std::ostream &out) const
| Writes a chunk of XML containing the data for this packet only. More...

## Detailed Description

### template<int dim>
class regina::Triangulation< dim >

A dim-dimensional triangulation, built by gluing together dim-dimensional simplices along their (dim-1)-dimensional facets.

Typically (but not necessarily) such triangulations are used to represent dim-manifolds.

Such triangulations are not the same as pure simplicial complexes, for two reasons:

- The only identifications that the user can explicitly specify are gluings between dim-dimensional simplices along their (dim-1)-dimensional facets. All other identifications between k-faces (for any k) are simply consequences of these (dim-1)-dimensional gluings. In contrast, a simplicial complex allows explicit gluings between faces of any dimension.
- There is no requirement for a k-face to have (k+1) distinct vertices (so, for example, edges may be loops). Many distinct k-faces of a top-dimensional simplex may be identified together as a consequence of the (dim-1)-dimensional gluings, and indeed we are even allowed to glue together two distinct factets of the same dim-simplex. In contrast, a simplicial complex does not allow any of these situations.

Amongst other things, this definition is general enough to capture any reasonable definition of a dim-manifold triangulation. However, there is no requirement that a triangulation must actually represent a manifold (and indeed, testing this condition is undecidable for sufficiently large dim).

You can construct a triangulation from scratch using routines such as newSimplex() and Simplex<dim>::join(). There are also routines for importing and exporting triangulations in bulk, such as isoSig() and fromIsoSig() (which uses isomorphism signatures), or insertConstruction() and dumpConstruction() (which exports C++ code).

In additional to top-dimensional simplices, this class also tracks:

- connected components of the triangulation, as represented by the class Component<dim>;
- boundary components of the triangulation, as represented by the class BoundaryComponent<dim>;
- lower-dimensional faces of the triangulation, as represented by the classes Face<dim, subdim> for subdim = 0,...,(dim-1).

Such objects are temporary: whenever the triangulation changes, they will be deleted and rebuilt, and any pointers to them will become invalid. Likewise, if the triangulation is deleted then all component objects will be deleted alongside it.

For Regina's standard dimensions, this template is specialised and offers much more functionality. In order to use these specialised classes, you will need to include the corresponding headers (e.g., triangulation/dim2.h for dim = 2, or triangulation/dim3.h for dim = 3).

Python:\n Python does not support templates. Instead
  this class can be used by appending the dimension as a suffix (e.g., Triangulation2 and Triangulation3 for dimensions 2 and 3).

Template Parameters

  dim | the dimension of the underlying triangulation. This must be between 2 and 15 inclusive.

## Member Typedef Documentation

## SafePointeeType

typedef Packet regina::SafePointeeBase< Packet >::SafePointeeType

inherited

The type of object being pointed to.

## Member Function Documentation

## deleteFaces()

void regina::detail::FaceListSuite< dim >::deleteFaces | ( |  | ) |

inline protected inherited

Deletes all faces of dimension subdim and below.

This routine destroys the corresponding Face objects and clears the lists that contain them.

## detail()

std::string regina::Output< Packet , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## fillFVector()

void regina::detail::FaceListSuite< dim >::fillFVector | ( | std::vector< size_t > & | result | ) | const

inline protected inherited

Fills the given vector with the first (subdim + 1) elements of the f-vector.

Specifically, this routine pushes the values f[0], ..., f[subdim] onto the end of the given vector, where f[k] denotes the number of k-faces that this object stores.

Parameters

  result | the vector in which the results will be placed.

## sameDegrees()

bool regina::detail::FaceListSuite< dim >::sameDegrees | ( | const FaceListSuite< dim, subdim > & | other | ) | const

inline protected inherited

Tests whether this and the given triangulation have the same k-face degree sequences, for each facial dimension k ≤ subdim.

For the purposes of this routine, degree sequences are considered to be unordered.

Precondition
  This and the given triangulation are known to have the same number of k-faces as each other, for each facial dimension k ≤ subdim.

Parameters

  other | the triangulation to compare against this.

Returns
  `true` if and only if all degree sequences considered are equal.

## sameFVector()

bool regina::detail::FaceListSuite< dim >::sameFVector | ( | const FaceListSuite< dim, subdim > & | other | ) | const

inline protected inherited

Tests whether this and the given triangulation have the same number of k-faces, for each facial dimension k ≤ subdim.

Parameters

  other | the triangulation to compare against this.

Returns
  `true` if and only if the face counts considered are identical for both triangluations.

## str()

std::string regina::Output< Packet , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## swapFaces()

void regina::detail::FaceListSuite< dim >::swapFaces | ( | FaceListSuite< dim, subdim > & | other | ) |

inline protected inherited

Swaps all faces of dimension subdim and below with those of the given triangulation.

Parameters

  other | the face storage for the triangulation whose faces are to be swapped with this.

## utf8()

std::string regina::Output< Packet , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

The documentation for this class was generated from the following files:

- triangulation/forward.h
- triangulation/generic/triangulation.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).